#include <hxcpp.h>

#ifndef INCLUDED_snow_platform_native_input_sdl_TouchEventTypes
#include <snow/platform/native/input/sdl/TouchEventTypes.h>
#endif
#ifndef INCLUDED_snow_platform_native_input_sdl_TouchState
#include <snow/platform/native/input/sdl/TouchState.h>
#endif
namespace snow{
namespace platform{
namespace native{
namespace input{
namespace sdl{

Void TouchEventTypes_obj::__construct()
{
	return null();
}

//TouchEventTypes_obj::~TouchEventTypes_obj() { }

Dynamic TouchEventTypes_obj::__CreateEmpty() { return  new TouchEventTypes_obj; }
hx::ObjectPtr< TouchEventTypes_obj > TouchEventTypes_obj::__new()
{  hx::ObjectPtr< TouchEventTypes_obj > result = new TouchEventTypes_obj();
	result->__construct();
	return result;}

Dynamic TouchEventTypes_obj::__Create(hx::DynamicArray inArgs)
{  hx::ObjectPtr< TouchEventTypes_obj > result = new TouchEventTypes_obj();
	result->__construct();
	return result;}

int TouchEventTypes_obj::te_down;

int TouchEventTypes_obj::te_up;

int TouchEventTypes_obj::te_move;

::snow::platform::native::input::sdl::TouchState TouchEventTypes_obj::typed( int te_type){
	HX_STACK_FRAME("snow.platform.native.input.sdl.TouchEventTypes","typed",0x12034abc,"snow.platform.native.input.sdl.TouchEventTypes.typed","snow/platform/native/input/sdl/InputSystem.hx",381,0x01aafc86)
	HX_STACK_ARG(te_type,"te_type")
	HX_STACK_LINE(383)
	if (((te_type == ::snow::platform::native::input::sdl::TouchEventTypes_obj::te_down))){
		HX_STACK_LINE(383)
		return ::snow::platform::native::input::sdl::TouchState_obj::down;
	}
	HX_STACK_LINE(384)
	if (((te_type == ::snow::platform::native::input::sdl::TouchEventTypes_obj::te_up))){
		HX_STACK_LINE(384)
		return ::snow::platform::native::input::sdl::TouchState_obj::up;
	}
	HX_STACK_LINE(385)
	if (((te_type == ::snow::platform::native::input::sdl::TouchEventTypes_obj::te_move))){
		HX_STACK_LINE(385)
		return ::snow::platform::native::input::sdl::TouchState_obj::move;
	}
	HX_STACK_LINE(387)
	return ::snow::platform::native::input::sdl::TouchState_obj::unknown;
}


STATIC_HX_DEFINE_DYNAMIC_FUNC1(TouchEventTypes_obj,typed,return )


TouchEventTypes_obj::TouchEventTypes_obj()
{
}

Dynamic TouchEventTypes_obj::__Field(const ::String &inName,bool inCallProp)
{
	switch(inName.length) {
	case 5:
		if (HX_FIELD_EQ(inName,"te_up") ) { return te_up; }
		if (HX_FIELD_EQ(inName,"typed") ) { return typed_dyn(); }
		break;
	case 7:
		if (HX_FIELD_EQ(inName,"te_down") ) { return te_down; }
		if (HX_FIELD_EQ(inName,"te_move") ) { return te_move; }
	}
	return super::__Field(inName,inCallProp);
}

Dynamic TouchEventTypes_obj::__SetField(const ::String &inName,const Dynamic &inValue,bool inCallProp)
{
	switch(inName.length) {
	case 5:
		if (HX_FIELD_EQ(inName,"te_up") ) { te_up=inValue.Cast< int >(); return inValue; }
		break;
	case 7:
		if (HX_FIELD_EQ(inName,"te_down") ) { te_down=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"te_move") ) { te_move=inValue.Cast< int >(); return inValue; }
	}
	return super::__SetField(inName,inValue,inCallProp);
}

void TouchEventTypes_obj::__GetFields(Array< ::String> &outFields)
{
	super::__GetFields(outFields);
};

static ::String sStaticFields[] = {
	HX_CSTRING("te_down"),
	HX_CSTRING("te_up"),
	HX_CSTRING("te_move"),
	HX_CSTRING("typed"),
	String(null()) };

#if HXCPP_SCRIPTABLE
static hx::StorageInfo *sMemberStorageInfo = 0;
#endif

static ::String sMemberFields[] = {
	String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(TouchEventTypes_obj::__mClass,"__mClass");
	HX_MARK_MEMBER_NAME(TouchEventTypes_obj::te_down,"te_down");
	HX_MARK_MEMBER_NAME(TouchEventTypes_obj::te_up,"te_up");
	HX_MARK_MEMBER_NAME(TouchEventTypes_obj::te_move,"te_move");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatics(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(TouchEventTypes_obj::__mClass,"__mClass");
	HX_VISIT_MEMBER_NAME(TouchEventTypes_obj::te_down,"te_down");
	HX_VISIT_MEMBER_NAME(TouchEventTypes_obj::te_up,"te_up");
	HX_VISIT_MEMBER_NAME(TouchEventTypes_obj::te_move,"te_move");
};

#endif

Class TouchEventTypes_obj::__mClass;

void TouchEventTypes_obj::__register()
{
	hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("snow.platform.native.input.sdl.TouchEventTypes"), hx::TCanCast< TouchEventTypes_obj> ,sStaticFields,sMemberFields,
	&__CreateEmpty, &__Create,
	&super::__SGetClass(), 0, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatics
#endif
#ifdef HXCPP_SCRIPTABLE
    , sMemberStorageInfo
#endif
);
}

void TouchEventTypes_obj::__boot()
{
	te_down= (int)1792;
	te_up= (int)1793;
	te_move= (int)1794;
}

} // end namespace snow
} // end namespace platform
} // end namespace native
} // end namespace input
} // end namespace sdl
